<?php



/***************************
 * Grille
 *
 */
class grille
{
	var $width = 5;
	var $height = 5;
	var $mots=null;
	var $seps=null;
	var $lang='FR';
	
	var $grille=null;
	
	///////////////////////////////////////////////////////////////
	function initGrille($width=5, $height=5, $chaine=null, $details=true)
	{
		//$this->debug('Début Init');
		
		$this->width=$width;
		$this->height=$height;
		
		for($i=0;$i<$width;$i++)
		{
			for($j=0;$j<$height;$j++)
			{
				//$this->debug('Cellule '.$i.'/'.$j);
				$this->grille[$i][$j]=new cellule();
				if($i>0) $this->grille[$i][$j]->setPrevLeft(& $this->grille[$i-1][$j]);
				if($j>0) $this->grille[$i][$j]->setPrevTop(& $this->grille[$i][$j-1]);
				if($chaine) 
				{
					$this->grille[$i][$j]->setLettre(substr($chaine,$i*$height+$j,1));
					if($this->grille[$i][$j]->getLettre()=='.') $this->grille[$i][$j]->UnsetLettre();
				}
			}
		}
		
		//Si chaine :
		//--> ajout des définitions
		//--> ajout des mots dans la collection
		//--> nettoyage des définitions en double
		//$this->debug('Définitions et mots');
		if($chaine && $details)
		{
			//Mots
			for($i=0;$i<$width;$i++)
			{
				for($j=0;$j<$height;$j++)
				{
					if($this->grille[$i][$j]->isLettre() && ($this->grille[$i][$j]->isDebutH() || $this->grille[$i][$j]->isDebutV()) ) 
					{
						$this->mots[$this->grille[$i][$j]->getMotH()]='';
						$this->mots[$this->grille[$i][$j]->getMotV()]='';
					}

				}
			}
			
			ksort($this->mots);
			//echo $this->getLettres();
		
			//Définitions
			$query="SELECT * FROM mots m
				LEFT JOIN definitions_actives d ON d.original=m.original
				WHERE m.mot IN ('".implode("', '",array_keys($this->mots))."')
				AND m.langue='".$this->lang."'
				AND d.langue='".$this->lang."'";
				
			//echo $query;
				
			$result=mysql_query($query);
			while($row=mysql_fetch_array($result))
			{
				$this->mots[$row['mot']]=utf8_encode($row['definition']);
			}
		
			//Application des définitions
			for($i=0;$i<$width;$i++)
			{
				for($j=0;$j<$height;$j++)
				{
					if(!$this->grille[$i][$j]->isLettre()) 
					{
						$this->grille[$i][$j]->addDefinitions($this->mots);
					}
				}
			}
			
			//Nettoyage des définitions
			for($i=0;$i<$width;$i++)
			{
				for($j=0;$j<$height;$j++)
				{
					if(!$this->grille[$i][$j]->isLettre()) $this->grille[$i][$j]->cleanDefinitions();
				}
			}
			
			//Séparateurs			
			$query="SELECT mot, separateurs FROM mots
				WHERE mot IN ('".implode("', '",array_keys($this->mots))."')
				AND langue='".$this->lang."'";
				
			//echo $query;
				
			$result=mysql_query($query);
			while($row=mysql_fetch_array($result))
			{
				$this->seps[$row['mot']]=utf8_encode($row['separateurs']);
			}
			
			//Application des séparateurs
			for($i=0;$i<$width;$i++)
			{
				for($j=0;$j<$height;$j++)
				{
					if(!$this->grille[$i][$j]->isLettre()) 
					{
						$this->grille[$i][$j]->setSeparateurs($this->seps);
					}

				}
			}
		}
		
		//$this->debug('Fin init');
	}
	
	///////////////////////////////////////////////////////////////
	function getCellule($i,$j)
	{
		return $this->grille[$i][$j];
	}
	
	///////////////////////////////////////////////////////////////
	function resetLettres()
	{
		$this->initGrille($this->width, $this->height);
	}
	///////////////////////////////////////////////////////////////
	function getLettres()
	{
		$toReturn='';
		
		for($i=0;$i<$this->width;$i++)
		{
			for($j=0;$j<$this->height;$j++)
			{
				$toReturn.=$this->grille[$i][$j]->getLettre();
			}
		}
		
		return $toReturn;
	}
	
	///////////////////////////////////////////////////////////////
	function resetTemp()
	{
		$query="UPDATE grilles_temp SET structure=vide WHERE largeur=".$this->width." AND hauteur=".$this->height." AND langue='".$this->lang."'";
		mysql_query($query);
	}
	
	///////////////////////////////////////////////////////////////
	function saveTemp()
	{
		$query="UPDATE grilles_temp SET structure='".$this->getLettres()."' WHERE largeur=".$this->width." AND hauteur=".$this->height." AND langue='".$this->lang."'";
		mysql_query($query);
	}
	////////////////////////////////////////////////
	function findWords($ln='FR')
	{
		//$this->debug('Début FindWord');
		//Essai de trouver des mots...	
		$tMots=array();
		
		$this->lang=$ln;
		
		//$this->resetTemp();
		
		//Recherche d'une grille non finie
		$query="SELECT structure FROM grilles_temp WHERE largeur=".$this->width." AND hauteur=".$this->height." AND langue='".$this->lang."'";
		$result=mysql_query($query);
		if(mysql_num_rows($result)==0)
		{
		
			for($i=0;$i<($this->height/2);$i++)
			{
				$this->getCellule(0,2*$i)->UnsetLettre();
			}
			for($i=0;$i<($this->width/2);$i++)
			{
				$this->getCellule(2*$i,0)->UnsetLettre();
			}
			
			for($i=0;$i<($this->width*$this->height)*0.2;$i++)
			{
				$case=$this->getCellule(rand(2,$this->width-1),rand(2,$this->height-1));

				if($case->prevTop->prevTop->isLettre() || $case->prevLeft->prevLeft->isLettre())
					$case->UnsetLettre();	
			}
			
			$chaine=$this->getLettres();
			$query="INSERT INTO grilles_temp 
				(largeur, hauteur, vide, structure, langue) 
				VALUES 
				(".$this->width.",".$this->height.",'".$chaine."','".$chaine."','".$this->lang."')";
			mysql_query($query);
		}
		else
		{
			$row=mysql_fetch_array($result);
			$this->initGrille($this->width,$this->height,$row['structure'],false);
		}

		//$this->debug('Chargement grille OK');
		
		$this->clearProbas($ln,false);
		
		//echo '<h2>Avant</h2>';
		//$this->drawSimpleGrille(true);
		
		//return false;

		$max=26;
		
		//$this->debug('Début boucle mots');
		
		for($max=$max;$max>1;$max--)
		{
			for($i=0;$i<$this->width;$i++)
			{
				for($j=0;$j<$this->height;$j++)
				{
					$case= & $this->grille[$i][$j];
					
					if((!$case->isDebutH() || !$case->isDebutV()) && $case->isLettre())
					{
						//$this->debug('Mot '.$this->lang);
					
						$long=$case->getLongueurH();
						if($long==$max)
						{
							//echo "<br/>$i-$j";
							if($case->findMotH(& $this->mots, $this->lang))
							{
								//$this->clearProbas($this->lang,false);
								$this->saveTemp();
								return false;
							}
						}
							
						$long=$case->getLongueurV();
						if($long==$max)
						{
							if($case->findMotV(& $this->mots, $this->lang))
							{
								//$this->clearProbas($this->lang,false);
								$this->saveTemp();
								return false;
							}
						}
					}
				}
			}
		}
		
		//$this->debug('Fin boucle mots');

		return true;
	}
	
	///////////////////////////////////////////////////////////
	function checkMots()
	{
		$query="SELECT mot FROM mots WHERE mot IN ('".implode("','",$this->mots)."')";
		$result=mysql_query($query);
		while($row=mysql_fetch_array($result))
		{
			$t[]=$row['mot'];
		}
		
		$t=array_diff(array_keys($this->mots),$t);
		
		for($i=0;$i<count($t);$i++)
			echo $t[$i];
	}
	
	function getMots($id)
	{
		/*$query="SELECT mot FROM mots_par_grille WHERE id_grille=".$id;
		$result=mysql_query($query);
		if(mysql_num_rows($result)>0)
		{
			while($row=mysql_fetch_array($result))
			{
				$t[]=$row['mot'];
			}
			return $t;
		}
		*/
		$t=null;
		$values='';
		for($i=0;$i<$this->width;$i++)
		{
			for($j=0;$j<$this->height;$j++)
			{
				$case=$this->getCellule($i,$j);
				if($case->isLettre())
				{
					$mot=$case->getMotH();
					if(strlen($mot)>1) $values.=",('$mot', $id)"; 
					$t[$mot]=1;
					$mot=$case->getMotV();
					if(strlen($mot)>1) $values.=",('$mot', $id)";
					$t[$mot]=1;
				}
			}
		}
		
		if($values) 
		{
			mysql_query("INSERT IGNORE INTO mots_par_grille(mot,id_grille) VALUES ".substr($values,1)."");
		}
		return $t;
	}
	
	///////////////////////////////////////
	
	function clearProbas($ln='fr',$lettre=true)
	{
		if(!$lettre)
		{
			for($i=0;$i<$this->width;$i++)
			{
				for($j=0;$j<$this->height;$j++)
				{
					$this->grille[$i][$j]->cleanProbas($ln);
				}
			}
		}
		else
		{
			for($i=0;$i<$this->width;$i++)
			{
				for($j=0;$j<$this->height;$j++)
				{
					if (!$this->grille[$i][$j]->cleanProbas($ln,true))
					{
						$this->clearProbas($ln,true);
						return;
					}
				}
			}
		}	
	}
	
	
	
	/////
	function drawSimpleGrille($writeLettres=false, $grille=null)
	{
		echo '<table>';
		for($j=0;$j<$this->height;$j++)
		{
			echo '<tr>';
			for($i=0;$i<$this->width;$i++)
			{
				echo '<td style="width:50px;height:50px;text-align:center;background-color:'.($this->grille[$i][$j]->isLettre()?'white':'black').';border:1px solid black;">';
				
				if($this->grille[$i][$j]->probas)
				{
					foreach($this->grille[$i][$j]->probas as $lettre=>$void)
						echo '<span style="font-size:6px;color:darkgreen">'.$lettre.'</span> ';
				}
				else
				{
					if($grille)
					{
						if($grille->grille[$i][$j]->getLettre()!==$this->grille[$i][$j]->getLettre())
						{
							echo '<span style="color:orange">'.($writeLettres?$this->grille[$i][$j]->getLettre():'&nbsp;').'</span>';
						}
						else
						{
							echo ($writeLettres?$this->grille[$i][$j]->getLettre():'&nbsp;');
						}
					}
					else
					{
						echo ($writeLettres?$this->grille[$i][$j]->getLettre():'&nbsp;');
					}
				}
				echo '</td>';
			}
			echo '</tr>';
		}
		echo '</table>
		<hr/>';
	}
	
	///////////////////////////////////////////////////////////////
	function drawGrille($id="", $ln='FR')
	{
		//Display
		//$this->debug('Début Draw');
		/*?>
		<i>Pour saisir les mots, cliquez sur leur définition.</i><hr/>
		<?php */
		$mots=array();
		
		$fond='';
		$files=null;
		$dir = "images/fonds";
		if(is_dir($dir))
		{
			$dh  = opendir($dir);
			while (false !== ($filename = readdir($dh))) {
				$files[] = $filename;
			}
			sort($files);
			$fond='/images/fonds/'.$files[rand(3,count($files)-2)];
		}

		$this->getMots($id);
		
		$query="SELECT DISTINCT mot FROM mots_par_grille WHERE id_grille=".$id."";
		$result5=mysql_query($query);
		
		if(mysql_num_rows($result5)==0)
		{
			?>

			<a target="_blank" href="/mots_a_definir.php"><img src="http://img.icbdr.com/images/js/help/caution.gif" alt="Il manque des définitions !" /> Cette grille est en manque de définitions !</a>
			<hr/>
			<?php
		}
		
		$query="SELECT * FROM mots WHERE mot IN (SELECT DISTINCT mot FROM mots_par_grille WHERE id_grille=".$id.") AND defini=0";
		$result5=mysql_query($query);
		
		if(mysql_num_rows($result5)>0)
		{
			?>

			<a target="_blank" href="/mots_a_definir.php"><img src="http://img.icbdr.com/images/js/help/caution.gif" alt="Il manque des définitions !" /> Cette grille est en manque de définitions !</a>
			<hr/>
			<?php
		}
		
		$cssWidth=100
		?>
		<table class="grille" style="background-image:url('<?php echo $fond ?>'),url('<?php echo $fond ?>');width:100%">
			<?php 
			for($j=0;$j<$this->height;$j++)
			{
			?><tr>
				<?php
				for($i=0;$i<$this->width;$i++)
				{
					$case=$this->getCellule($i,$j);
					
					if(!$case->isLettre())
					{
						?>
						<td<?php
						$t=null;
						$min=8;
						if($case->defLR && $case->nextRight) 
							$t[]=WriteDef($case->defLR,$i,$j,$i+1,$j,'R',$case->nextRight->getLongueurH(),$case->nextRight->getMotH(),$this->width,$this->height);
						if($case->defLB && $case->nextRight) 
							$t[]=WriteDef($case->defLB,$i,$j,$i+1,$j,'B',$case->nextRight->getLongueurV(),$case->nextRight->getMotV(),$this->width,$this->height);
						
						if($case->defTB && $case->nextBottom) 
							$t[]=WriteDef($case->defTB,$i,$j,$i,$j+1,'B',$case->nextBottom->getLongueurV(),$case->nextBottom->getMotV(),$this->width,$this->height);
						if($case->defTR && $case->nextBottom) 
							$t[]=WriteDef($case->defTR,$i,$j,$i,$j+1,'R',$case->nextBottom->getLongueurH(),$case->nextBottom->getMotH(),$this->width,$this->height);
						
						if($t) 
							echo ' class="definition"><div class="def">'.implode('<hr/>',$t).'</div>'; else echo '>&nbsp;'
						?>
						</td>
						<?php
					}
					else
					{
						$mots[$case->getMotH()]='';
						$mots[$case->getMotV()]='';
						
						?>
						<td class="lettre<?php echo ($case->separateurH?' sepH':'').($case->separateurV?' sepV':'') ?>">
						<?php
							//echo $case->getLettre();
						?>
							<!-- <input type="text" id="lettre_<?php echo $i ?>_<?php echo $j ?>" maxlength="1" readonly="readonly"/> -->
							<div id="lettre_<?php echo $i ?>_<?php echo $j ?>"></div>
							<input type="hidden"  id="hidden_<?php echo $i ?>_<?php echo $j ?>" value="<?php echo $case->getLettre(); ?>"/>
						</td>
						<?php
					}
				}
				?></tr><?php
			}
			?>
		</table>
		<hr/><img src="/images/boutons/valider.png" height="100" alt="Verifier ma saisie" onclick="TestGrille(<?php echo $this->width ?>,<?php echo $this->height ?>);"/>
		<img  title="Un petit coup de pouce ?" onclick="AddLetter(<?php echo $this->width ?>,<?php echo $this->height ?>);" src="/images/boutons/wizard.png" height="100"/>
		<img  title="Je me l'imprime pour plus tard" target="_blank" onclick="document.location.href='/impression.php<?php echo ($id?'?id='.$id:'') ?>'" src="/images/boutons/pdf.png" height="100"/>
		<img title="Allez, j'abandonne..." onclick="FillGrille(<?php echo $this->width ?>,<?php echo $this->height ?>);TestGrille(<?php echo $this->width ?>,<?php echo $this->height ?>);" src="/images/boutons/solution.png" height="100"/>
		<hr/>
		<?php
		
		$query="SELECT DISTINCT mot FROM mots WHERE mot IN ('".implode("','",array_keys($mots))."') AND langue='$ln'";
		$result=mysql_query($query);
		while($row=mysql_fetch_array($result))
		{
			?>
			<div id="mot_<?php echo $row['mot'] ?>" style="display:none;text-align:left; padding:15px;position:relative;">
				<?php echo $row['mot'] ?> 
				<?php
				$query="SELECT original FROM mots WHERE mot='".$row['mot']."' and langue='$ln'";
				$result2=mysql_query($query);
				while($row2=mysql_fetch_array($result2))
				{
					?>(<a href="http://fr.wiktionary.org/wiki/<?php echo utf8_encode($row2['original']) ?>" target="_blank" title="Voir sa définition"><?php echo utf8_encode($row2['original']) ?></a>)<?php
				}
				?>				
				 : <ul>
				<?php
				$query="SELECT * FROM definitions_actives d
					INNER JOIN comptes c ON c.id_compte=d.id_compte
					INNER JOIN mots m ON m.original=d.original
					WHERE m.mot='".$row['mot']."' and d.langue='$ln'";
				$result2=mysql_query($query);
				while($row2=mysql_fetch_array($result2))
				{
					echo '<li><i>'.utf8_encode($row2['definition']).'</i>, proposée par <b>'.utf8_encode($row2['pseudo']).'</b> - <a href="report.php?id_def='.$row2['id_definition'].'">Signaler comme incorrecte</a> - <a href="mots_a_definir.php?mot='.utf8_encode($row2['original']).'">Ajoutez votre définition</a></li>';
				}
				?>
				</ul>
			</div>
			<?php
		}
	
		?>
		<script type="text/javascript" src="/_config/js/grille.js"></script>
		<?php

		//$this->debug('Fin Draw');
	}
	
	/////////////////////////////////////////////////
	/////////////////////////////////////////////////
	/////////////////////////////////////////////////
	function debug($texte)
	{
		echo '<span style="font-size:6pt;color:#ddd">'.date('H:i:s').' : '.$texte.'</span><br/>';
	}
}



?>
