<?php

//Initialisation

global $pdf;


function SetNewPageFeC($titre='',$image=true, $filigrane='')
{

    global $pdf;

    //Nouvelle page
    $pdf->AddPage();
	//Filigrane

	if($filigrane)
		AddFiligrane(utf8_decode($filigrane));
    //Ajout image

	if($image)
	{
		$pdf->Image('http://fleches-et-croix.fr/images/boutons/favicon_pdf.jpg',10,8,30);
		$pdf->SetXY(10,40);
		$pdf->SetFont('Arial','U',9);
		$pdf->SetTextColor(0,0,255);
		$pdf->Cell(100,16,'http://www.fleches-et-croix.fr',0,0,'L',0,'http://www.fleches-et-croix.fr');
		$pdf->SetTextColor(0,0,0);
		$pdf->SetFont('Arial','',9);
		$pdf->SetXY(30,20);
		//$pdf->Cell(100,16,'Siret : 512 502 279 00015',0,0,'L',0);
	}
    //Ajout infos entreprise
    //Ajout titre

    if($titre)
    {
        $pdf->SetDrawColor(128,128,128);
        $pdf->SetXY(95,10);
        $pdf->SetFont('Arial','B',50);
        $pdf->Cell(100,16,$titre,'B',0,'R');
    }
	$pdf->SetXY(10,60);
}

function WriteCellule($x,$y,$dim=15,$defs=null)
{

	global $pdf;

	$size=round($dim/2,0)-1;
	$pdf->SetFont('Arial','',$size);
	$pdf->SetFillColor(255);

	if(is_array($defs)) $pdf->SetFillColor(0);

	if($defs===true) $pdf->SetFillColor(128);
    $pdf->SetTextColor(255);
    $pdf->SetDrawColor(128);
    $pdf->SetLineWidth(.3);
	$pdf->SetXY($x,$y);
	$pdf->Cell($dim,$dim,'',1,0,'C',$defs!=null);
}

function WriteFleches($x,$y,$dim=15,$defs=null)
{

	global $pdf;

	if(is_array($defs))
	{
		$pdf->SetFillColor(0);
		$h=$dim/4.5;		
		$pdf->SetXY($x,$y);
		$top=$pdf->GetY();

		foreach($defs as $code=>$def)
		{			
			$pdf->SetXY($x,$top);
			$pdf->MultiCell($dim,$h,$def,0,'C',0);
			//Fleche

			switch($code)
			{

				case 'LB':

					if(isset($defs['LR']))
						$pdf->Image('http://fleches-et-croix.fr/images/'.$code.'.jpg',$x+$dim+0.3,$y+($dim/2),3);
					else
						$pdf->Image('http://fleches-et-croix.fr/images/'.$code.'.jpg',$x+$dim+0.3,$y+0.3,3);
					break;

				case 'LR':		

					if(isset($defs['TB']))
						$pdf->Image('http://fleches-et-croix.fr/images/'.$code.'.jpg',$x+$dim+0.3,$y+0.6,3);
					else
						$pdf->Image('http://fleches-et-croix.fr/images/'.$code.'.jpg',$x+$dim+0.3,$y+0.3,3);
					break;

				case 'TB':

					if(isset($defs['LR']))
						$pdf->Image('http://fleches-et-croix.fr/images/'.$code.'.jpg',$x+0.3,$y+$dim+0.6,0,3);
					else
						$pdf->Image('http://fleches-et-croix.fr/images/'.$code.'.jpg',$x+0.3,$y+$dim+0.3,0,3);
					break;

				case 'TR':
					$pdf->Image('http://fleches-et-croix.fr/images/'.$code.'.jpg',$x+($dim/2),$y+$dim+0.3,0,3);
					break;
			}
			$top=$pdf->GetY()+1;
		}
	}
}

